std::_Optional_base< _Tp, bool, bool > Struct Template Reference
Utilities

`#include <optional>`

Inheritance diagram for std::_Optional_base< _Tp, bool, bool >:
[legend]

## Public Member Functions

constexpr | _Optional_base (_Optional_base &&__other) noexcept(is_nothrow_move_constructible_v< _Tp >)
constexpr | _Optional_base (const _Optional_base &__other)
template<typename... _Args, enable_if_t< is_constructible_v< _Tp, _Args... >, bool > = false>
constexpr | _Optional_base (in_place_t, _Args &&... __args)
template<typename _Up , typename... _Args, enable_if_t< is_constructible_v< _Tp, initializer_list< _Up > &, _Args... >, bool > = false>
constexpr | _Optional_base (in_place_t, initializer_list< _Up > __il, _Args &&... __args)
_Optional_base & | operator= (_Optional_base &&)=default
_Optional_base & | operator= (const _Optional_base &)=default

## Public Attributes

_Optional_payload< _Tp > | _M_payload

## Protected Types

using | _Stored_type = remove_const_t< _Tp >

## Protected Member Functions

template<typename... _Args>
constexpr void | _M_construct (_Args &&... __args) noexcept(is_nothrow_constructible_v< _Stored_type, _Args... >)
constexpr void | _M_destruct () noexcept
constexpr const _Tp & | _M_get () const noexcept
constexpr _Tp & | _M_get () noexcept
constexpr bool | _M_is_engaged () const noexcept
constexpr void | _M_reset () noexcept

## Detailed Description

template<typename _Tp, bool = is_trivially_copy_constructible_v<_Tp>, bool = is_trivially_move_constructible_v<_Tp>>
struct std::_Optional_base< _Tp, bool, bool >

Class template that provides copy/move constructors of optional.

Such a separate base class template is necessary in order to conditionally make copy/move constructors trivial.

When the contained value is trivially copy/move constructible, the copy/move constructors of _Optional_base will invoke the trivial copy/move constructor of _Optional_payload. Otherwise, they will invoke _Optional_payload(bool, const _Optional_payload&) or _Optional_payload(bool, _Optional_payload&&) to initialize the contained value, if copying/moving an engaged optional.

Whether the other special members are trivial is determined by the _Optional_payload<_Tp> specialization used for the _M_payload member.

See also
  optional, _Enable_special_members

Definition at line 472 of file optional.

## Member Typedef Documentation

## _Stored_type

template<typename _Tp , typename _Dp >

using std::_Optional_base_impl< _Tp, _Dp >::_Stored_type = remove_const_t<_Tp>

protected inherited

Definition at line 410 of file optional.

## Constructor & Destructor Documentation

## _Optional_base() [1/4]

template<typename _Tp , bool = is_trivially_copy_constructible_v<_Tp>, bool = is_trivially_move_constructible_v<_Tp>>
template<typename... _Args, enable_if_t< is_constructible_v< _Tp, _Args... >, bool > = false>

constexpr std::_Optional_base< _Tp, bool, bool >::_Optional_base | ( | in_place_t | ,
|  | _Args &&... | __args
| ) |  |

inline explicit constexpr

Definition at line 482 of file optional.

## _Optional_base() [2/4]

template<typename _Tp , bool = is_trivially_copy_constructible_v<_Tp>, bool = is_trivially_move_constructible_v<_Tp>>
template<typename _Up , typename... _Args, enable_if_t< is_constructible_v< _Tp, initializer_list< _Up > &, _Args... >, bool > = false>

constexpr std::_Optional_base< _Tp, bool, bool >::_Optional_base | ( | in_place_t | ,
|  | initializer_list< _Up > | __il,
|  | _Args &&... | __args
| ) |  |

inline explicit constexpr

Definition at line 491 of file optional.

## _Optional_base() [3/4]

template<typename _Tp , bool = is_trivially_copy_constructible_v<_Tp>, bool = is_trivially_move_constructible_v<_Tp>>

constexpr std::_Optional_base< _Tp, bool, bool >::_Optional_base | ( | const _Optional_base< _Tp, bool, bool > & | __other | ) |

inline constexpr

Definition at line 499 of file optional.

## _Optional_base() [4/4]

template<typename _Tp , bool = is_trivially_copy_constructible_v<_Tp>, bool = is_trivially_move_constructible_v<_Tp>>

constexpr std::_Optional_base< _Tp, bool, bool >::_Optional_base | ( | _Optional_base< _Tp, bool, bool > && | __other | ) |

inline constexpr noexcept

Definition at line 504 of file optional.

## Member Function Documentation

## _M_construct()

template<typename _Tp , typename _Dp >
template<typename... _Args>

constexpr void std::_Optional_base_impl< _Tp, _Dp >::_M_construct | ( | _Args &&... | __args | ) |

inline constexpr protected noexcept inherited

Definition at line 416 of file optional.

## _M_destruct()

template<typename _Tp , typename _Dp >

constexpr void std::_Optional_base_impl< _Tp, _Dp >::_M_destruct | ( |  | ) |

inline constexpr protected noexcept inherited

Definition at line 424 of file optional.

## _M_get() [1/2]

template<typename _Tp , typename _Dp >

constexpr const _Tp & std::_Optional_base_impl< _Tp, _Dp >::_M_get | ( |  | ) | const

inline constexpr protected noexcept inherited

Definition at line 444 of file optional.

## _M_get() [2/2]

template<typename _Tp , typename _Dp >

constexpr _Tp & std::_Optional_base_impl< _Tp, _Dp >::_M_get | ( |  | ) |

inline constexpr protected noexcept inherited

Definition at line 437 of file optional.

## _M_is_engaged()

template<typename _Tp , typename _Dp >

constexpr bool std::_Optional_base_impl< _Tp, _Dp >::_M_is_engaged | ( |  | ) | const

inline constexpr protected noexcept inherited

Definition at line 432 of file optional.

## _M_reset()

template<typename _Tp , typename _Dp >

constexpr void std::_Optional_base_impl< _Tp, _Dp >::_M_reset | ( |  | ) |

inline constexpr protected noexcept inherited

Definition at line 429 of file optional.

## Member Data Documentation

## _M_payload

template<typename _Tp , bool = is_trivially_copy_constructible_v<_Tp>, bool = is_trivially_move_constructible_v<_Tp>>

_Optional_payload<_Tp> std::_Optional_base< _Tp, bool, bool >::_M_payload

Definition at line 514 of file optional.

The documentation for this struct was generated from the following file:

- optional